action.yml 7.5 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206
  1. # NOTE: Do not rely on `make` commands here as this action is used across different repos
  2. # where the Makefile will not be available
  3. name: 'Sentry Setup'
  4. description: 'Sets up a Sentry test environment'
  5. inputs:
  6. workdir:
  7. description: 'Directory where the sentry source is located'
  8. required: false
  9. default: '.'
  10. snuba:
  11. description: 'Is snuba required?'
  12. required: false
  13. default: 'false'
  14. clickhouse:
  15. description: 'Is clickhouse required?'
  16. required: false
  17. default: 'false'
  18. kafka:
  19. description: 'Is kafka required?'
  20. required: false
  21. default: 'false'
  22. chartcuterie:
  23. description: 'Is chartcuterie required?'
  24. required: false
  25. default: 'false'
  26. bigtable:
  27. description: 'Is bigtable required?'
  28. required: false
  29. default: 'false'
  30. redis_cluster:
  31. description: 'Is redis cluster required?'
  32. required: false
  33. default: 'false'
  34. symbolicator:
  35. description: 'Is symbolicator required?'
  36. required: false
  37. default: 'false'
  38. peanutbutter:
  39. description: 'Is peanutbutter required?'
  40. required: false
  41. default: 'false'
  42. python-version:
  43. description: 'python version to install'
  44. required: false
  45. default: '3.12.3'
  46. pg-version:
  47. description: 'PostgreSQL version to use'
  48. default: '14'
  49. required: false
  50. outputs:
  51. yarn-cache-dir:
  52. description: 'Path to yarn cache'
  53. value: ${{ steps.config.outputs.yarn-cache-dir }}
  54. matrix-instance-number:
  55. description: 'The matrix instance number (starting at 1)'
  56. value: ${{ steps.config.outputs.matrix-instance-number }}
  57. matrix-instance-total:
  58. description: 'Reexport of MATRIX_INSTANCE_TOTAL.'
  59. value: ${{ steps.config.outputs.matrix-instance-total }}
  60. runs:
  61. using: 'composite'
  62. steps:
  63. - name: Setup default environment variables
  64. # the default for "bash" is:
  65. # bash --noprofile --norc -eo pipefail {0}
  66. shell: bash --noprofile --norc -eo pipefail -ux {0}
  67. env:
  68. MATRIX_INSTANCE: ${{ matrix.instance }}
  69. # XXX: We should be using something like len(strategy.matrix.instance) (not possible atm)
  70. # If you have other things like python-version: [foo, bar, baz] then the sharding logic
  71. # isn't right because job-total will be 3x larger and you'd never run 2/3 of the tests.
  72. # MATRIX_INSTANCE_TOTAL: ${{ strategy.job-total }}
  73. run: |
  74. echo "PIP_DISABLE_PIP_VERSION_CHECK=on" >> $GITHUB_ENV
  75. echo "PIP_INDEX_URL=https://pypi.devinfra.sentry.io/simple" >> $GITHUB_ENV
  76. echo "SENTRY_SKIP_BACKEND_VALIDATION=1" >> $GITHUB_ENV
  77. ### node configuration ###
  78. echo "NODE_ENV=development" >> $GITHUB_ENV
  79. ### pytest configuration ###
  80. echo "PY_COLORS=1" >> "$GITHUB_ENV"
  81. echo "PYTEST_ADDOPTS=--reruns=5 --durations=10 --fail-slow=60s" >> $GITHUB_ENV
  82. echo "COVERAGE_CORE=sysmon" >> "$GITHUB_ENV"
  83. ### pytest-sentry configuration ###
  84. if [ "$GITHUB_REPOSITORY" = "getsentry/sentry" ]; then
  85. echo "PYTEST_SENTRY_DSN=https://6fd5cfea2d4d46b182ad214ac7810508@sentry.io/2423079" >> $GITHUB_ENV
  86. echo "PYTEST_SENTRY_TRACES_SAMPLE_RATE=0" >> $GITHUB_ENV
  87. # This records failures on master to sentry in order to detect flakey tests, as it's
  88. # expected that people have failing tests on their PRs
  89. if [ "$GITHUB_REF" = "refs/heads/master" ]; then
  90. echo "PYTEST_SENTRY_ALWAYS_REPORT=1" >> $GITHUB_ENV
  91. fi
  92. fi
  93. # Configure a different release version, otherwise it defaults to the
  94. # commit sha which will conflict with our actual prod releases. This is a
  95. # confusing experience because it looks like these are "empty" releases
  96. # because no commits are attached and associates the release with our
  97. # javascript + sentry projects.
  98. echo "SENTRY_RELEASE=ci@$GITHUB_SHA" >> $GITHUB_ENV
  99. # this handles pytest test sharding
  100. if [ "$MATRIX_INSTANCE" ]; then
  101. if ! [ "${MATRIX_INSTANCE_TOTAL:-}" ]; then
  102. echo "MATRIX_INSTANCE_TOTAL is required."
  103. exit 1
  104. fi
  105. echo "TEST_GROUP=$MATRIX_INSTANCE" >> $GITHUB_ENV
  106. echo "TOTAL_TEST_GROUPS=$MATRIX_INSTANCE_TOTAL" >> $GITHUB_ENV
  107. fi
  108. - uses: getsentry/action-setup-venv@a133e6fd5fa6abd3f590a1c106abda344f5df69f # v2.1.0
  109. with:
  110. python-version: ${{ inputs.python-version }}
  111. cache-dependency-path: ${{ inputs.workdir }}/requirements-dev-frozen.txt
  112. install-cmd: cd ${{ inputs.workdir }} && python3 -m tools.hack_pip && pip install -r requirements-dev-frozen.txt
  113. - name: Set up outputs
  114. id: config
  115. env:
  116. MATRIX_INSTANCE: ${{ matrix.instance }}
  117. shell: bash --noprofile --norc -eo pipefail -ux {0}
  118. run: |
  119. echo "yarn-cache-dir=$(yarn cache dir)" >> "$GITHUB_OUTPUT"
  120. echo "matrix-instance-number=$(($MATRIX_INSTANCE+1))" >> "$GITHUB_OUTPUT"
  121. echo "matrix-instance-total=$((${MATRIX_INSTANCE_TOTAL:-}))" >> "$GITHUB_OUTPUT"
  122. - name: Install python dependencies
  123. shell: bash --noprofile --norc -eo pipefail -ux {0}
  124. env:
  125. # This is necessary when other repositories (e.g. relay) want to take advantage of this workflow
  126. # without needing to fork it. The path needed is the one where setup.py is located
  127. WORKDIR: ${{ inputs.workdir }}
  128. run: |
  129. cd "$WORKDIR"
  130. # We need to install editable otherwise things like check migration will fail.
  131. python3 -m tools.fast_editable --path .
  132. - name: Start devservices
  133. shell: bash --noprofile --norc -eo pipefail -ux {0}
  134. env:
  135. NEED_KAFKA: ${{ inputs.kafka }}
  136. NEED_SNUBA: ${{ inputs.snuba }}
  137. NEED_CLICKHOUSE: ${{ inputs.clickhouse }}
  138. NEED_BIGTABLE: ${{ inputs.bigtable }}
  139. NEED_CHARTCUTERIE: ${{ inputs.chartcuterie }}
  140. NEED_REDIS_CLUSTER: ${{ inputs.redis_cluster }}
  141. NEED_SYMBOLICATOR: ${{ inputs.symbolicator }}
  142. NEED_PEANUTBUTTER: ${{ inputs.peanutbutter }}
  143. WORKDIR: ${{ inputs.workdir }}
  144. PG_VERSION: ${{ inputs.pg-version }}
  145. ENABLE_AUTORUN_MIGRATION_SEARCH_ISSUES: '1'
  146. run: |
  147. sentry init
  148. # redis, postgres are needed for almost every code path.
  149. services=(redis postgres)
  150. if [ "$NEED_CLICKHOUSE" = "true" ] || [ "$NEED_SNUBA" = "true" ]; then
  151. services+=(clickhouse)
  152. fi
  153. if [ "$NEED_SNUBA" = "true" ]; then
  154. services+=(snuba)
  155. fi
  156. if [ "$NEED_BIGTABLE" = "true" ]; then
  157. echo "BIGTABLE_EMULATOR_HOST=127.0.0.1:8086" >> $GITHUB_ENV
  158. services+=(bigtable)
  159. fi
  160. if [ "$NEED_CHARTCUTERIE" = "true" ]; then
  161. services+=(chartcuterie)
  162. fi
  163. if [ "$NEED_REDIS_CLUSTER" = "true" ]; then
  164. services+=(redis-cluster)
  165. fi
  166. if [ "$NEED_SYMBOLICATOR" = "true" ]; then
  167. services+=(symbolicator)
  168. fi
  169. if [ "$NEED_PEANUTBUTTER" = "true" ]; then
  170. services+=(peanutbutter)
  171. fi
  172. if [ "$NEED_KAFKA" = "true" ]; then
  173. services+=(kafka)
  174. fi
  175. sentry devservices up "${services[@]}"
  176. # have tests listen on the docker gateway ip so loopback can occur
  177. echo "DJANGO_LIVE_TEST_SERVER_ADDRESS=$(docker network inspect bridge --format='{{(index .IPAM.Config 0).Gateway}}')" >> "$GITHUB_ENV"
  178. docker ps -a
  179. # This is necessary when other repositories (e.g. relay) want to take advantage of this workflow
  180. # without needing to fork it. The path needed is the one where tools are located
  181. cd "$WORKDIR"